<?php


namespace App\Controller;


use Doctrine\ORM\EntityManagerInterface;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

/**
 * @Route("/number-of-sold-by-region", name="number_of_sold_by_region")
 */
class NumberOfSoldByRegion extends AbstractController
{
    /**
     * Entity Manager
     */
    private $em;
    public function __construct(EntityManagerInterface $em) {
        $this->em = $em;
    }

    public function __invoke(Request $request) {
        $query = "  SELECT
                        valeurs_fonciere.code_departement AS code_departement,
                        COUNT(valeurs_fonciere.code_departement) AS count_by_departement
                    FROM
                        App:ValeursFonciere AS valeurs_fonciere
                    WHERE
                        valeurs_fonciere.code_departement > 0
                        AND
                        lower(valeurs_fonciere.nature_mutation) = 'vente'
                    GROUP BY 
                        valeurs_fonciere.code_departement";
        $counts_by_departement = $this->em->createQuery($query)->getResult();
        foreach ($counts_by_departement as &$count_by_departement){
            $count_by_departement['code_departement'] = intval($count_by_departement['code_departement']);
            $count_by_departement['count_by_departement'] = intval($count_by_departement['count_by_departement']);
        }
        $res = new JsonResponse(
            $counts_by_departement,
            Response::HTTP_OK
        );
        return $res;
    }
}
